//
//  lottery_iphoneViewController.h
//  lottery-iphone
//
//  Created by 木谷 公哉 on 09/07/08.
//  Copyright 京都大学東南アジア研究センター 2009. All rights reserved.
//
//  抽選プログラム。とりあえず過去データの保管は無視して、完全ランダムをやってみる

#import <UIKit/UIKit.h>
#import "global-define.h"; // 共通変数、定義ファイル（0.4）: 2009.07.30

@interface lottery_iphoneViewController : UIViewController {
	IBOutlet UIButton *clipButton;		// クリップボードアクセスボタン(0.4)
    IBOutlet UIButton *drawingButton;  // 抽選ボタン
	IBOutlet UIButton *resultDisableButton;  // 抽選結果無効ボタン 0.5 -- 有効にもできる (0.53)
	IBOutlet UIButton *resultRecoverButton;  // 回復ボタン 0.5
	IBOutlet UIButton *initNumberSequenceButton; // 初期化のボタン 0.6 (ローカナイズ用）
    IBOutlet UITextField *maxNumber;   // 番号の最大値のテキストフィールド
    IBOutlet UITextField *pastNumbers; // 過去の履歴のテキストフィールド（データをコピーしたりできるのでテキストフィールドにしている）
	IBOutlet UILabel *eXresultNumber; // 外部出力用 0.9
    IBOutlet UILabel *resultNumber; // 現在の抽選の値のラベル 
    IBOutlet UILabel *nextNumber; // 次の抽選の値のラベル
	IBOutlet UILabel *nextNumberView; // 次の抽選の値の説明ラベル
    IBOutlet UILabel *prevNumber; // 一つ前の抽選の値のラベル
	IBOutlet UILabel *prevNumberView; // 一つ前の抽選の値の説明ラベル
	IBOutlet UILabel *labelMaxNumberMsg; // 番号の最大値のラベル表示 0.6 ローカナイズ専用
	IBOutlet NSString *result;   // 現在の抽選の値
	IBOutlet UILabel *currentSeqNum; // 現在の抽選の回数 0.9
	IBOutlet UILabel *attention; // 普段は履歴表示だが、メッセージ出したいときに使う
	
		
	IBOutlet UIView     *view; // メインView (0.70)
	IBOutlet UIView     *exview; // 外部出力用 (0.9)
		
	// HELPビュー
	IBOutlet UIView		 *HELP; // ヘルプView (0.70)
	IBOutlet UIButton    *help_done; // ヘルプViewの終了 (0.70)
	IBOutlet UILabel	 *help_exp; //説明 (0.70)

	// Modeビュー
	IBOutlet UIView		 *UserMode; // 0.9: ユーザモード
	IBOutlet UILabel	 *resultNumber_s; // 現在の抽選の回数 0.9（ユーザモード）
	IBOutlet UIButton *drawingButton_s;  // 抽選ボタン 0.9（ユーザモード）

    NSMutableArray *nums;        // 番号の最大値分だけの数値を保管（初期化で順序をランダム変更）
    int	seq;                     // 現在表示の場所（$nums[$seq]が現在の抽選番号）
    int maxOfSeq;				 // 番号の最大値
	int os_version;				 // OSバージョン（ViewDidLoadで値を入れる） 0.9
	NSMutableArray *nums_status; // 抽選結果が無効なら-1, 有効なら1を入れる0.5。
	
	
	UIWindow *externalWindow;	// 外部ディスプレイ用 0.9
	//UIInterfaceOrientation willInterfaceOrientation; // 回転後の位置情報。 0.81 (2010.05.06)

	
	
	
}
- (IBAction) goDrawing: (id) sender;            // 抽選の処理
- (IBAction) initNumberSequence: (id) sender;   // 初期化の処理

- (IBAction) keyclose: (id)sender; // キーボードを閉じる（0.2）

- (void)setButtonEnable: (UIButton *)button status:(BOOL)s;      // 特定ボタンを有効・無効にする
- (void)setNotes: (UILabel *)label text:(NSString *)s;           // 特定ラベルに、特定文字を表示
- (void)KeyboardStatus: (UITextField *)object status:(BOOL)s;	 // キーボード表示・非表示（keycloseで使う）（0.2）
- (void)setHiddenStatus: (id)object status:(BOOL)s;				 // オブジェクトの表示と非表示（0.3）

// クリップボード関連（0.4) 2009.07.30
- (IBAction) setClipBoardController: (id)sender; // クリップボードへの書き込み
- (NSString *) getCLipBoard; // クリップボードからデータを取得
- (void) setCLipBoard: (NSString *)str; //クリップボードへデータを書き込む

// 該当者なしをおしたときの処理 (0.5) 2009.07.30
- (IBAction)setThisNumberStatus:(id) sender; 
- (IBAction)setRecoverResult:(id) sender; 

// 該当者無し以外のデータを返り値として返す 0.52 2009.07.30
- (NSString *) getResultNumbers;

// ボタンのタイトルを変更する。変更前のタイトルを返り値とする 0.54 2009.07.30
- (NSString *)setTitleButton: (UIButton *)button text:(NSString *)change_str;


// 終了時の処理 (0.6) 2009.08.05: willTerminateは終了時の処理メソッドとして予約されている
// これをオーバーロードすることで処理ができる。
- (void)willTerminate: (UIApplication *)application;

// データの初期化 (0.6) 2009.08.05 保存したデータを戻す
- (void)initializeData;

// HELPビューへの移動 (0.70) 2009.11.10
- (IBAction)moveHELPView:(id) sender;

// メインビューへの移動 (0.70) 2009.11.10
- (IBAction)moveMainView:(id) sender;

// ユーザビューとメインタビューの切り替え (0.90) 2011.04.05
- (IBAction)changeModeView:(id) sender;



// 0.70: 2009.11.10 / HPへのアクセスボタンの追加
-(IBAction)GoToURL;
// 0.81: 2010.05.18 / バージョンや著者情報を出す。
-(IBAction)AboutMe;


@end
