//
//  lottery_iphoneViewController.m
//  lottery-iphone
//
//  Created by 木谷 公哉 on 09/07/08.
//  Copyright 京都大学東南アジア研究所 2009. All rights reserved.
//

#import "lottery_iphoneViewController.h"

@implementation lottery_iphoneViewController

// (0.6) 2009.08.05: データの保存と取り出し
#import "DataStore.h"

// 「抽選」ボタンをおしたときの処理。nums[seq]からデータを取り出して表示。seqが最大番号になったら終了。
- (IBAction) goDrawing:(id) sender	
{
	// 抽選を始めて押したときに、次の抽選結果を表示する。（メソッド内ですでに表示していたら処理しないようにしたいが・・） (0.3)
    // とりあえずはseqが0（最初）だけ実行ってことで。
	if(seq == 0){
		[self setHiddenStatus:nextNumber status:NO]; 
		[self setHiddenStatus:nextNumberView status:NO];
	}else if(seq > 0){ // 2回目以降なら一つ前を表示
		[self setHiddenStatus:prevNumber status:NO]; 
		[self setHiddenStatus:prevNumberView status:NO];
    }
	NSNumber *thisNumber = [nums objectAtIndex: seq]; // 配列を作って、seq番のデータ（抽選結果）を取得
	resultNumber.text = [thisNumber stringValue]; // 抽選結果表示のラベルに抽選結果の数値を文字列に変換してセット
	resultNumber_s.text = [thisNumber stringValue]; // 0.9（ユーザモード）
	eXresultNumber.text = [thisNumber stringValue]; // 0.9: 外部出力
	resultNumber.textColor = [UIColor blackColor]; // 　該当者なしにしたら結果表示を消す。それ以外は黒 0.51
	resultNumber_s.textColor = [UIColor blackColor]; // 　0.9（ユーザモード）
	eXresultNumber.textColor = [UIColor blackColor]; // 0.9: 外部出力

	// 回数 0.9
	currentSeqNum.text = [NSString stringWithFormat:@"%d %@", seq+1, NSLocalizedString(SEQ_MSG, @"")];
	[currentSeqNum sizeToFit];

	// 抽選ボタンが押されたら回数を表示 0.9 2010.10.06
	[self setHiddenStatus:currentSeqNum status:NO];

	// 履歴に抽選結果情報を追加
	pastNumbers.text = [NSString stringWithFormat: @"%@ %d", [pastNumbers text],[thisNumber intValue]];
	//eXpastNumbers.text = [NSString stringWithFormat: @"%@ %d", [eXpastNumbers text],[thisNumber intValue]]; // 0.9: 外部出力用
	// 0.9: 外部出力用：結果表示ラベルの高さ調整（http://ja.efreedom.com/Question/1-446405/%E3%83%86%E3%82%AD%E3%82%B9%E3%83%88%E3%81%AB%E5%BF%9C%E3%81%97%E3%81%A6-UILabel-%E9%AB%98%E3%81%95%E3%82%92%E8%AA%BF%E6%95%B4%E3%81%97%E3%81%BE%E3%81%99）
    //----
/*
    //CGSize max_LabelSize = CGSizeMake(600, 9999);
	//CGSize expectedLabelSize = [eXpastNumbers.text sizeWithFont:eXpastNumbers.font
	//							constrainedToSize:max_LabelSize
	//							lineBreakMode:eXpastNumbers.lineBreakMode];
	//CGRect newframe = eXpastNumbers.frame;
	//newframe.size.height = expectedLabelSize.height;
	//eXpastNumbers.frame = newframe;
	// サイズ変更だ。
	//scroll.contentSize =  CGSizeMake(eXpastNumbers.frame.size.width,);
*/	
    //----
	
	seq++; // 一つ先があるかどうかなど調べる
	// seq++しているんで、２回目は2になっている
	if(seq >= 2){
		NSNumber *prevNum= [nums objectAtIndex: seq-2]; // 前の抽選結果を取得(seq++しているので絶対にseq-1 >= 0）
		int prevNum_status = [[nums_status objectAtIndex: seq-2] intValue]; // 該当者なしボタンをおしたか？ 0.52
		// 次の抽選結果表示ラベルに次の抽選結果数値を文字列に変換してセット
		if(prevNum_status == 1) 
			prevNumber.text = [NSString stringWithFormat: @"%d", [prevNum intValue]];
		else if(prevNum_status == -1) // 0.52
			prevNumber.text = [NSString stringWithFormat: @"(%d)", [prevNum intValue]];
		else
			prevNumber.text = nil; // あり得ないことが起こったら表示しないことにする。

	}	
	
	if(seq>=maxOfSeq)	{
		// 0.6 ローカナイズ 2009.08.05
		pastNumbers.text = [NSString stringWithFormat: @"%@ - %@", [pastNumbers text], NSLocalizedString(FINISH_MSG, @"")];
		nextNumber.text = NSLocalizedString(FINISH_MSG, @""); // (0.3) --> 0.6 ローカナイズ
		[self setButtonEnable:drawingButton status:NO];
		[self setButtonEnable:drawingButton_s status:NO]; // 0.9 (ユーザモード）
	}else{ // (0.3)
		NSNumber *nextNum= [nums objectAtIndex: seq]; // 次の抽選結果を取得（かならずseq+1 < maxOfSeqでなければならないのでここにいれる
		// 次の抽選結果表示ラベルに次の抽選結果数値を文字列に変換してセット
		nextNumber.text = [NSString stringWithFormat: @"%d", [nextNum intValue]];
	}
	[self setButtonEnable:clipButton status:YES]; // クリップボードへコピーするボタンを有効化（抽選ボタンを押したら: 0.4）
	[self setButtonEnable:resultDisableButton status:YES]; // 該当者なしボタンは抽選を押したら有効 (0.5)
	[self setButtonEnable:resultRecoverButton status:YES]; // 回復ボタンは抽選んを押したら有効 (0.5)
	// NSString *temp = RESULT_DISABLE_STR; // 0.55: #defineの最後に;を入れてなければ下記がうごく。
	[self setTitleButton:resultDisableButton text:RESULT_DISABLE_STR]; // 0.54 (該当なしの初期化）

}

// Mode切り替え (0.90: 2011.04.05)
- (IBAction)changeModeView:(id) sender
{
	
	// 予め、移動先のViewをaddSubviewしておくこと。
	// [self.view addSubview: HELP];
	// HELP.alpha = 0.0; で隠しとく。
	// http://iphone-dev.ensites.net/archives/tag/uiview
	[UIView beginAnimations:nil context:nil]; // アニメーション開始
	[UIView setAnimationDuration:0.4]; // 0.4秒で

	// メインビューが表示されていたら、ユーザビューに移動
	if (UserMode.alpha == 0.0){
  	  view.alpha = 0.0; // 現在のViewを透明にして、
	  UserMode.alpha = 1.0; // ユーザモードビューを有効
	  // 0.9: ユーザモードの結果表示を最大表示にする
	  resultNumber_s.font	= [UIFont systemFontOfSize:64*(resultNumber_s.frame.size.height / 64)];
	  resultNumber_s.adjustsFontSizeToFitWidth = YES;

	}else if(UserMode.alpha == 1.0){ // ユーザビューが表示されていたら、メインビューに戻す
	  UserMode.alpha = 0.0; // ユーザモードビューを無効にして
	  view.alpha = 1.0; // メインビューを表示
	}
	
	[UIView commitAnimations]; // あたかも切り替わったように見せる。
	
}

// HELPビューに移動 (0.70: 2009.11.10)
- (IBAction)moveHELPView:(id) sender
{
	
		// 予め、移動先のViewをaddSubviewしておくこと。
		// [self.view addSubview: HELP];
		// HELP.alpha = 0.0; で隠しとく。
		// http://iphone-dev.ensites.net/archives/tag/uiview
		[UIView beginAnimations:nil context:nil]; // アニメーション開始
		[UIView setAnimationDuration:0.4]; // 0.4秒で

		view.alpha = 0.0; // 現在のViewを透明にして、
		HELP.alpha = 1.0;  // 指定したViewを不透明にして、
		[UIView commitAnimations]; // あたかも切り替わったように見せる。

}

// メインビューに移動 (0.70: 2009.11.10)
- (IBAction)moveMainView:(id) sender
{
	
	// 予め、移動先のViewをaddSubviewしておくこと。
	// [self.view addSubview: HELP];
	// HELP.alpha = 0.0; で隠しとく。
	// http://iphone-dev.ensites.net/archives/tag/uiview
	[UIView beginAnimations:nil context:nil]; // アニメーション開始
	[UIView setAnimationDuration:0.4]; // 0.4秒で
	
	view.alpha = 1.0; // 現在のViewを透明にして、
	HELP.alpha = 0.0;  // 指定したViewを不透明にして、
	[UIView commitAnimations]; // あたかも切り替わったように見せる。
	
}

// 0.70: 2009.11.10 / HPへのアクセスボタンの追加
-(IBAction)GoToURL {
	[[UIApplication sharedApplication] openURL:[NSURL URLWithString:NSLocalizedString(GoToHP, @"")]];
}

//回復ボタンを押したときの処理（結果表示を再描写する） 0.5
// 基本は、setThisNumberStatusを参考にしている。
- (IBAction)setRecoverResult:(id) sender
{
	pastNumbers.text = [NSString stringWithFormat: @"Initialized by %d - ", maxOfSeq ];

    // 抽選結果である$nums[]に対して、無効なら()で括る処理を、抽選結果表示に再描写する。
	for(int i=0; i < seq; i++){
		int this_nums_status = [[nums_status objectAtIndex: i] intValue]; 
		if(this_nums_status == 1){
			pastNumbers.text = [NSString stringWithFormat: @"%@ %d", [pastNumbers text], [[nums objectAtIndex: i] intValue]];
		}else if(this_nums_status == -1){
			pastNumbers.text = [NSString stringWithFormat: @"%@ (%d)", [pastNumbers text], [[nums objectAtIndex: i] intValue]];
		}
	}
}

// 今現在の抽選結果の「該当者なし」ボタンを押したときに処理 0.5
- (IBAction)setThisNumberStatus:(id) sender 
{
	// 0.6 2009.08.05 以下、定義のローカナイズ
	// 該当者なしボタンのの確認（0.53 - #defineで制御）
	NSString *rd_str = NSLocalizedString(RESULT_DISABLE_STR, @"");
//	if(resultDisableButton.titleLabel.text == rd_str){ // 該当者なしなら
    // 文字列比較を正しく訂正 0.55（ただし日本語はUTF-8ならうごくが、そんな比較はよくないとのこと
	// それは後から考える。
	if([resultDisableButton.titleLabel.text isEqualToString:rd_str]){ // 該当者なしなら
		rd_str = NSLocalizedString(RESULT_ENABLE_STR, @"");
	}else{
		rd_str = NSLocalizedString(RESULT_DISABLE_STR, @"");
	}

 
 //[resultDisableButton setTitle:rd_str forState:UIControlStateNormal];
	// 0.54 (メソッドを使う）
	[self setTitleButton: resultDisableButton text:rd_str];

	NSString *rn_str = NSLocalizedString(RESULT_ENABLE_STR, @"");

	// 0.53 （該当者なしにしてからありに変更する機能を追加）
//	if(rn_str != rd_str){ // 該当者あり --> なしの処理
	if(! [rn_str isEqualToString:rd_str]){ // 0.55 (文字列比較の間違った方法を是正）
		resultNumber.textColor = [UIColor blackColor]; // 結果を再表示
		resultNumber_s.textColor = [UIColor blackColor]; // 結果を再表示（0.9: ユーザモード）
		eXresultNumber.textColor = [UIColor blackColor]; // 0.9: 外部出力用
		[nums_status replaceObjectAtIndex:seq-1 withObject:[NSNumber numberWithInt:1]]; // フラグを有効に変更
	}else{ // 該当者なしボタンをおしたとき。
		// この時点でseqは次の抽選番号の順番になっている。
		resultNumber.textColor = [UIColor clearColor]; // 　該当者なしにしたら結果表示を消す。それ以外は黒 0.51
		resultNumber_s.textColor = [UIColor clearColor]; // 　該当者なしにしたら結果表示を消す。それ以外は黒 0.51（0.9: ユーザモード）
		eXresultNumber.textColor = [UIColor clearColor]; // 0.9: 外部出力用
		[nums_status replaceObjectAtIndex:seq-1 withObject:[NSNumber numberWithInt:-1]];  // 抽選結果フラグに値を入れる。0.5
	}
	pastNumbers.text = [NSString stringWithFormat: @"Initialized by %d - ", maxOfSeq ];
    // 抽選結果である$nums[]に対して、無効なら()で括る処理を、抽選結果表示に再描写する。
	for(int i=0; i < seq; i++){
		int this_nums_status = [[nums_status objectAtIndex: i] intValue]; 
		if(this_nums_status == 1){
			pastNumbers.text = [NSString stringWithFormat: @"%@ %d", [pastNumbers text], [[nums objectAtIndex: i] intValue]];
		}else if(this_nums_status == -1){
			pastNumbers.text = [NSString stringWithFormat: @"%@ (%d)", [pastNumbers text], [[nums objectAtIndex: i] intValue]];
		}
	}
}

// 「初期化」ボタンを押したときに処理。
- (IBAction)initNumberSequence:(id) sender 
{
	// 回数 0.9（初期化）
	currentSeqNum.text = nil;
	[self setHiddenStatus:currentSeqNum status:YES];
	
	// 入力した「番号の最大値」の値を入れる
	maxOfSeq = [[maxNumber text] intValue];
	//eXmaxNumber.text = [maxNumber text]; // 0.9: 外部出力
	// ０以下は意味がないので、エラーを出す。一応10万以下にしておく（バッファオーバーフロー対策）
	// 10万以上だと手持ちのものは時間係りすぎるね。
	if(maxOfSeq <=0 || maxOfSeq > 100000){
		[self setNotes:attention text:ERROR_OVER_NUM];
		maxNumber.text = nil;
		//eXmaxNumber.text = nil; // 0.9: 外部出力用
		return;
	}else{
		[self setNotes:attention text:VIEW_HISTORY]; // 0.6: 2009.08.05でローカナイズ
		//[self setNotes:eXattention text:VIEW_HISTORY]; // 0.9: 外部出力用
	}
	
    
	// 初期化されるので抽選結果の次や前の表示は非表示で、データもクリアだよね。
	nextNumber.text=nil;  [self setHiddenStatus:nextNumber status:YES]; // 非表示する場合
	[self setHiddenStatus:nextNumberView status:YES];
	prevNumber.text=nil;  [self setHiddenStatus:prevNumber status:YES]; // 非表示する場合(0.41)
	[self setHiddenStatus:prevNumberView status:YES];
	resultNumber.text=nil; 
	resultNumber_s.text=nil; // 0.9:（ユーザモード） 
	eXresultNumber.text=nil; // 外部出力用 0.9
	
	// numsが「１」〜「番号の最大値」までを格納する配列。それがメモリに存在したら解放（初期化）
	// ２度目の初期化のときに利用する
	if(nums != nil)
		[nums release];
	if(nums_status != nil) // 抽選結果のクリア。 0.5
		[nums_status release];

	// 一度ひいたくじは二度と引かないので、最大番号数までの配列を用意し、予め順番を明らかにする
	nums = [[NSMutableArray arrayWithCapacity: maxOfSeq] retain];
	// 抽選結果のフラグ(0.5) -- 
	nums_status = [[NSMutableArray arrayWithCapacity: maxOfSeq] retain];
	// まずは順番に数字（重ならない）を入れる
    for(int i=0; i<maxOfSeq; i++){
		[nums addObject: [NSNumber numberWithInt: i+1]];
		[nums_status addObject: [NSNumber numberWithInt: 1]]; //　初期化
	}
    seq = 0; // これは順番（抽選を押す度にカウントがあがる）
	
	// 以下、順番を変える（これで数字が重ならずに順番がバラバラになる）
	// 順番を変えるためには、maxOfSeq範囲内の２つのランダム番号を出して、それを入れ替える
	// それを適当な回数繰り返せばいい（100という数字の場合、100回シャッフルは多すぎるかもしれないが10回では足りるか？という
	// 問題。まぁ面倒なので後で考える。1億とか入れられたらそのうちメモリ不足になりそうなので、どこかで制限しておかないといけないね。
	// ここで抽選結果全部を蓄えたということ。最初に全部計算して後は表示するだけにできる
    // 0.9: arc4random()に変更。どうやらこちらのほうがよいとのことなので
	//srand((unsigned)time(NULL)); // ランダムの種を仕込む（面倒なので、定番の時間で変化する種とする）
	
	// 10000までなら、そのまま、10000以上なら10000回にするための計算式　0^0 = 1, 0^1以上= 0を活用
	// まぁ最低maxOfSeqぐらいしないとこのアルゴリズムではシャッフル度が腐るので下記の考えは止める。
	//int reparting = maxOfSeq % 10000 + pow(0, maxOfSeq % 10000) * 10000;
	//[self setNotes:attention text:[NSString stringWithFormat: @"%d", reparting]];

    int reparting = maxOfSeq;
	
	for(int i=0; i<reparting; i++){ //とりあえずmaxOfSeq回数繰り返してみる（ここらへんはもっとうまくできるかも）
/*
		int index1 = rand() % maxOfSeq; // 「rand()割るmaxOfSeqの余り」を計算（0〜[maxOfSeq-1]になる。nums[0]〜nums[maxOfseq-1]に使う
		int index2 = rand() % maxOfSeq;
*/
		int index1 = arc4random() % maxOfSeq; // 「rand()割るmaxOfSeqの余り」を計算（0〜[maxOfSeq-1]になる。nums[0]〜nums[maxOfseq-1]に使う
		int index2 = arc4random() % maxOfSeq;
    if(index1 == index2) // 同じ数字になる可能性はもちろんある。その場合には処理せずループの次の処理へ
			continue;
		// nums[index1]とnums[index2]の値の入れ替え処理。
		NSNumber *x1 = [nums objectAtIndex: index1]; // index1のデータ抜き出し
		NSNumber *x2 = [nums objectAtIndex: index2]; // index2のデータ抜き出し
		[nums replaceObjectAtIndex:index1 withObject:x2]; //index1にindex2の抜き出したデータを上書き
		[nums replaceObjectAtIndex:index2 withObject:x1]; //index2にindex1の抜き出したデータを上書き
	}
	
	pastNumbers.text = [NSString stringWithFormat: @"Initialized by %d - ", maxOfSeq ];
	[self setButtonEnable:drawingButton status:YES]; // 初期化が終われば、「抽選」ボタンを有効化
	[self setButtonEnable:drawingButton_s status:YES]; // 初期化が終われば、「抽選」ボタンを有効化 0.9: ユーザモード
	[self setButtonEnable:clipButton status:NO]; // クリップボードへコピーするボタンの無効化（初期化したら）(0.4)
	[self setButtonEnable:resultDisableButton status:NO]; // 該当者なしボタンは初期化を押しても無効 (0.5)
	[self setButtonEnable:resultRecoverButton status:NO]; // 回復ボタンはは初期化を押しても無効 (0.5)

    // テキストフィールドのキーボードをすべて閉じる
 	[self KeyboardStatus:maxNumber status:NO];
	[self KeyboardStatus:pastNumbers status:NO];

}

// 0.54: 現在のButtonのtitleをreturnで返す。
-(NSString *)setTitleButton: (UIButton *)button text:(NSString *)change_str
{
	NSString *getButtonTitle = [[button titleLabel] text]; // 現在のButtonのタイトルを取得（button.titleLabel.textでもよし）
	//[button setTitle:change_str forState:UIControlStateNormal]; // 新しいタイトルをセット
	[button setTitle:NSLocalizedString(change_str, @"") forState:UIControlStateNormal]; // 新しいタイトルをセット 0.6 2009.08.05 ローカナイズ

	return getButtonTitle;
}

//ボタンの有効・無効化を選択（無効の場合には無効っぽい色に変更）
// statusは、ラベルのこと（[self setButtonEnable:drawingButton status:YES];などとして呼ぶ）
// 初期値：http://xcatsan.blogspot.com/2009/02/blog-post.html
// 色：http://profo.jp/wiki/index.php?UIColor
// (UIButton *) --> (id)にしたい。それにはbutton.alphaが問題。buttonの型チェックが必要だと思う（未実装）
- (void)setButtonEnable: (UIButton *)button status:(BOOL)s
{
    [button setEnabled: s];
//   [button setHidden: !s]; // 非表示する場合

	// 不透明度（アルファー値）は0〜1の間で、指定する。1なら完全不透明、0なら完全透明。
	// ちょっと不透明にしておけば、ボタンが押せない状態だということが視覚的に分かりやすくなる。
	if(s) // YES（ボタンを有効化したなら）
      button.alpha = 1.0;
	else // NO（ボタンを無効化したなら）
	  button.alpha = 0.5;

}

// (id)にすることでUITextField, UIButton, UILabel等で使える。オブジェクトの表示＝YES, 非表示=NO (0.3) 2009.07.29
- (void)setHiddenStatus: (id)object status:(BOOL)s
{
		[object setHidden: s]; 
}



// 特定ラベルに、特定文字を表示
-(void)setNotes: (UILabel *)label text:(NSString *)s
{
	label.text = NSLocalizedString(s, @""); // 0.6 2009.08.05 ローカナイズ
}

// キーボードを隠すアクション（0.2）
- (IBAction) keyclose: (id)sender
{
	[self KeyboardStatus:sender status:NO];
	
	// Touch Downに紐づけてやれば、クリックするたびに表示、非表示となる
}

// キーボードを非表示・表示のメソッド。YES=表示、 NO=非表示（0.2）
-(void) KeyboardStatus: (UITextField *)object status:(BOOL)s
{
	[object endEditing:!s];
}

/****
 ** クリップボード関連
 **
 *****/

//クリップボードのセット
- (IBAction) setClipBoardController: (id)sender
{
	// 抽選履歴に文字がある場合には、それをクリップボードにセット
	if([pastNumbers text] != nil)
		[self setCLipBoard: [self getResultNumbers]];
		
}

// クリップボードからデータ取得（0.4）
// http://d.hatena.ne.jp/yaguta/20090703/1246642104
- (NSString *) getCLipBoard
{
	// システムで共有するクリップボードへのアクセス
	UIPasteboard *clip = [UIPasteboard generalPasteboard];
	// クリップボードからデータ取得
	return clip.string;
}
// クリップボードへデータ書き込み（0.4）
// http://d.hatena.ne.jp/yaguta/20090703/1246642104
- (void) setCLipBoard: (NSString *)str
{
	// システムで共有するクリップボードへのアクセス
	UIPasteboard *clip = [UIPasteboard generalPasteboard];
	// クリップボードへデータ書き込み
	if(str != nil)
		[clip setString: str];
}

// 該当者無し以外のデータを返り値として返す 0.52
- (NSString *) getResultNumbers
{
	// これが呼び出されるときには、必ずseqは１つ先を指し示している。
	NSString *str = [NSString stringWithFormat: @"Total (%d) - ", maxOfSeq ];
	for(int i=0; i < seq; i++){
		int this_nums_status = [[nums_status objectAtIndex: i] intValue]; 
		if(this_nums_status == 1)
			str = [NSString stringWithFormat: @"%@ %d", str, [[nums objectAtIndex: i] intValue]];
	}
	return str;

}

// HELPビューに、Aboutボタンを付けて、バージョンや著者情報を出す（Alert）0.81 2010.05.17
// http://developer.apple.com/jp/technotes/tn2006/tn2179.html
-(IBAction)AboutMe{
    NSString *title = NSLocalizedString(@"CFBundleDisplayName",nil);
	NSString *messages = NSLocalizedString(@"CFBundleGetInfoString",nil);
//	NSString *message2 = NSLocalizedString(@"NSHumanReadableCopyright",nil);
//	NSString *messages = [NSString stringWithFormat:@"%@\n%@",message1, message2];
	UIAlertView *alert = [[UIAlertView alloc] initWithTitle:title message:messages delegate:self cancelButtonTitle:@"OK" otherButtonTitles: nil];
	
	[alert show];
	[alert release];

}


/*
// The designated initializer. Override to perform setup that is required before the view is loaded.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        // Custom initialization
    }
    return self;
}
*/

/*
// Implement loadView to create a view hierarchy programmatically, without using a nib.
- (void)loadView {

}
*/

// 3.1以前でもコンパイルできるように、4.0非対応メソッドは条件付きでコンパイルする 0.9: 外部出力用
#if	__IPHONE_OS_VERSION_MAX_ALLOWED >= 30200

- (void)screenDidConnect{
	NSLog(@"Enable Video Out");
	NSArray *screens = [UIScreen screens];
	for (UIScreen *screen in screens){
		// メインスクリーン以外であれば
		if(screen != [UIScreen mainScreen]){
			NSArray *modes = [screen availableModes]; // 対応解像度をチェック
			CGSize max_screen;
			UIScreenMode *maxScreenMode;
			
			for (UIScreenMode *mode in modes){
				// 対応解像度からもっとも高いものを選択する
				if(max_screen.width < mode.size.width){
					max_screen = mode.size;
					maxScreenMode = mode;
				}
			}
			// まだ外部ウィンドウが開かれてないなら
			if(externalWindow == nil){			
				screen.currentMode = maxScreenMode; // 解像度設定
				externalWindow = [[UIWindow alloc] initWithFrame:CGRectMake(0, 0, maxScreenMode.size.width, maxScreenMode.size.height)];
				externalWindow.backgroundColor = [UIColor grayColor];

				// 0.9: 外部出力用（Viewサイズは外部スクリーン次第で変更）
				CGRect frame;
				frame.size.width = maxScreenMode.size.width;
				frame.size.height = maxScreenMode.size.height;
				[exview setFrame:frame];

				// 0.9: 外部出力用
				//[eXpastNumbers setLineBreakMode:UILineBreakModeWordWrap]; //改行モード（0.9: 外部出力用）
				//eXpastNumbers.numberOfLines = 0; // ラベルを複数行OKにする（0.9: 外部出力用）
				exview.clipsToBounds = YES;
				// 結果表示は、640x480, 1024x768, 1280x720と縦を軸にして考えるのがよい。
				// 横方向は自動調整を有効にしとけばいいしね。
				eXresultNumber.font	= [UIFont systemFontOfSize:64*(eXresultNumber.frame.size.height / 64)];
				eXresultNumber.adjustsFontSizeToFitWidth = YES;
				//eXpastNumbers.font  = [UIFont systemFontOfSize:24];
				[externalWindow addSubview:exview]; // 表示するViewを設定
				
				externalWindow.screen = screen; 
				externalWindow.hidden = NO;
				[externalWindow makeKeyAndVisible]; // スクリーンへ表示
 
			}
		}
	}
 
}
		 

- (void)screenDidDisconnect{
	// ビューを外部ウィンドウから取り除く
	[view removeFromSuperview];
	// 外部ウィンドウを解放する
	[externalWindow release];
	externalWindow = nil;
}

#endif

// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.

// 起動時（実際には起動して描写後の処理）
- (void)viewDidLoad {
	[super viewDidLoad];

	// 外部ディスプレイ対応（0.9)
	// iOS4以上なら
	// OSバージョンチェック 0.9 2010.10.06
     //    os_version = [[UIDevice currentDevice].systemVersion intValue];

    // 0.9 
#if __IPHONE_OS_VERSION_MAX_ALLOWED >= 30200
    // 外部スクリーン接続のノーティフィケーションを登録
    // 0.9: これ入れておかないと、iOS 3.1.3のiPod touch 1stでは実機起動が失敗する
    if ([[[UIDevice currentDevice] systemVersion] floatValue] >= 3.2) {

		[[NSNotificationCenter defaultCenter] addObserver:self 
											 selector:@selector(screenDidConnect) 
												 name:UIScreenDidConnectNotification 
											   object:nil];
	
		[[NSNotificationCenter defaultCenter] addObserver:self 
											 selector:@selector(screenDidDisconnect) 
												 name:UIScreenDidDisconnectNotification 
											   object:nil];	
	
		// 外部スクリーンに接続
		[self screenDidConnect];
    }	
#endif
	
	// メッセージラベルの初期化（この文字列は、定義したほうがいいでしょう）0.6でローカナイズ: 2009.08.05
	[self setNotes:attention text:VIEW_HISTORY];
	//[self setNotes:eXattention text:VIEW_HISTORY]; // 0.9: 外部出力用
	// 「抽選」ボタンは触れないようにしておく。
	[self setButtonEnable:drawingButton status:NO]; // setButtonEnable(drawingButton, "NO");みたいなもの
	[self setButtonEnable:drawingButton_s status:NO]; // setButtonEnable(drawingButton, "NO");みたいなもの 0.9: ユーザモード
	[self setButtonEnable:clipButton status:NO]; // クリップボードへコピーするボタンはまずは無効化
	[self setButtonEnable:resultDisableButton status:NO]; // 該当者なしボタンはまずは無効化 (0.5)
	[self setButtonEnable:resultRecoverButton status:NO]; // 回復ボタンはまずは無効化 (0.5)
	
	// 該当者なしボタンの初期化（0.53 - #defineで制御）
	// http://ameblo.jp/xcc/entry-10156594753.html  
	//NSString *temp = RESULT_DISABLE_STR;  // #defineの最後は「;」を入れちゃダメ。でも左のようにしたら通るんですよね・・・。
    // [resultDisableButton setTitle:temp forState:UIControlStateNormal]; // ここは直接指定しないとうまく動かない（ボタンタイトルの切り替えができない）
	// ボタンのタイトルの全初期化（ローカナイズ対応） 0.6 2009.08.05
	[self setTitleButton:resultDisableButton text:RESULT_DISABLE_STR]; // 0.54: 0.55（文字列比較を直してみたらOK）
	[self setTitleButton:drawingButton text:BUTTON_drawingButton];
	[self setTitleButton:drawingButton_s text:BUTTON_drawingButton]; //0.9 ユーザモード
	[self setTitleButton:clipButton text:BUTTON_clipButton];
	[self setTitleButton:resultRecoverButton text:BUTTON_resultRecoverButton];
	[self setTitleButton:initNumberSequenceButton text:BUTTON_initNumberSequenceButton];
	[self setTitleButton:help_done text:BUTTON_BackButton]; // 0.70: 2009.11.10
	
	// ラベルのローカナイズ 0.6 2009.08.05
	// setNotesを使った（0.9 2010.10.06)
	[self setNotes:labelMaxNumberMsg text:NSLocalizedString(MaxNumberMsg, @"")];
	//[self setNotes:eXlabelMaxNumberMsg text:NSLocalizedString(MaxNumberMsg, @"")]; // 外部出力用
	[self setNotes:nextNumberView text:NSLocalizedString(NextNumberMsg, @"")];
	[self setNotes:prevNumberView text:NSLocalizedString(PrevNumberMsg, @"")];
	
	/*
	labelMaxNumberMsg.text	= NSLocalizedString(MaxNumberMsg, @"");
	//eXlabelMaxNumberMsg.text	= NSLocalizedString(MaxNumberMsg, @""); // 外部出力用
	nextNumberView.text		= NSLocalizedString(NextNumberMsg, @"");
	prevNumberView.text		= NSLocalizedString(PrevNumberMsg, @"");
    */
	// ヘルプビューの説明文 0.70 2009.11.10
	// http://profo.jp/wiki/index.php?UILabel
	help_exp.numberOfLines = 0; // ラベルを複数行OKにする

	// 回数の初期化 0.9 2010.10.06
	currentSeqNum.text = nil; [self setHiddenStatus:currentSeqNum status:YES];
	
	
#if (__IPHONE_OS_VERSION_MAX_ALLOWED >= 30200)
    if (UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPad) {
		help_exp.font			= [UIFont systemFontOfSize:35]; // UIFont: http://profo.jp/wiki/index.php?UIFont#vb152ec9
	}else {
		help_exp.font			= [UIFont systemFontOfSize:17]; // UIFont: http://profo.jp/wiki/index.php?UIFont#vb152ec9
	}
#else
	help_exp.font			= [UIFont systemFontOfSize:17]; // UIFont: http://profo.jp/wiki/index.php?UIFont#vb152ec9
#endif
	
	help_exp.text			= NSLocalizedString(HELP_EXP, @""); //ローカナイズ
	
	
	// テキストフィールドはすべて、セットされた文字は自動的にクリアしないように設定
	maxNumber.clearsOnBeginEditing = NO; 
	pastNumbers.clearsOnBeginEditing = NO;
	// 結果表示ラベルはデータなしにしておく（Interface Builderでは、何のラベルかわからないのでコメントしておく）
	resultNumber.text = nil;
	resultNumber_s.text = nil; // 0.9:（ユーザモード）
	eXresultNumber.text = nil; // 0.9: 外部出力用
	//eXmaxNumber.text = nil;  // 0.9: 外部出力用
	//eXpastNumbers.text = nil; // 0.9: 外部出力用
	// 次の抽選結果は、抽選ボタンをおした時に表示がいいね。 (0.3)
	nextNumber.text = nil; [self setHiddenStatus:nextNumber status:YES]; // 非表示する場合
    [self setHiddenStatus:nextNumberView status:YES];
	// 一つ前の抽選結果は、抽選ボタンをおして２回目からの表示だよね(0.3)
	prevNumber.text = nil; [self setHiddenStatus:prevNumber status:YES]; // 非表示する場合
    [self setHiddenStatus:prevNumberView status:YES];
	
	maxNumber.keyboardType = UIKeyboardTypeNumberPad;  // 数値入力は、数字入力パットのキーレイアウトにセット

	[self initializeData]; // (0.6) 2009.08.05 実装のみで、このバージョンでは無効（DateRestoreでreturn FALSE;なんで）

	// (0.70) 2009.11.10: HELPビューをメインビューの上に透明で被せておく。
	// http://stackoverflow.com/questions/1087458/multiple-views-in-one-nib-addsubview

    [self.view addSubview:HELP];
	HELP.alpha = 0.0;
    [self.view addSubview:UserMode]; // 0.9 (ユーザモードビュー）
	UserMode.alpha = 0.0;
	
}


// データの初期化 (0.6)
- (void)initializeData
{
	LOG(@"### initializeDate\n");
	//NSMutableArray *array = [[[NSMutableArray alloc] initWithCapacity:1] autorelease];
	NSArray *array; // これで上記ができるようだ。0.61: 2009.08.05 --> 2009.08.13
 	// データがあるときだけ
	if( (array = [self DataRestore:STORE_NAME]) != nil){
      /*
		     LOG([NSString stringWithFormat: @"%d", [[array objectAtIndex:2] intValue]]);
			maxNumber.text = [[array objectAtIndex:2] stringValue];
	   */
		
		// 0.61: 2009.08.14
		nums		= [array objectAtIndex:0];
		nums_status = [array objectAtIndex:1];
		maxOfSeq	= [[array objectAtIndex:2] intValue];
		maxNumber.text = [[array objectAtIndex:2] stringValue];
		//eXmaxNumber.text = [[array objectAtIndex:2] stringValue]; // 外部出力用 0.9
		seq		 = [[array objectAtIndex:3] intValue];
		resultNumber.text = [array objectAtIndex:4];
		resultNumber_s.text = [array objectAtIndex:4]; // 0.9: ユーザモード
		eXresultNumber.text = [resultNumber text]; // 外部出力用 0.9
		if(maxOfSeq > 0 && seq < maxOfSeq){
			[self setButtonEnable:drawingButton status:YES]; // setButtonEnable(drawingButton, "NO");みたいなもの
			[self setButtonEnable:drawingButton_s status:YES]; // setButtonEnable(drawingButton, "NO");みたいなもの 0.9 ユーザモード
		}
		[self setButtonEnable:clipButton status:YES]; // クリップボードへコピーするボタンはまずは無効化
		[self setButtonEnable:resultDisableButton status:YES]; // 該当者なしボタンはまずは無効化 (0.5)
		[self setButtonEnable:resultRecoverButton status:YES]; // 回復ボタンはまずは無効化 (0.5)
		// seqはメモリ保存した段階でseq+1となっているため
		// つまり数値的に1が最低（0から始まる）。
		if(seq >= 1){
			// 回数 0.9
			currentSeqNum.text = [NSString stringWithFormat:@"%d %@", seq, NSLocalizedString(SEQ_MSG, @"")];
			[currentSeqNum sizeToFit];
			[self setHiddenStatus:currentSeqNum status:NO];
			
			if(seq < maxOfSeq)
				nextNumber.text = [[nums objectAtIndex:seq] stringValue];
			else
				nextNumber.text = NSLocalizedString(FINISH_MSG, @""); 

			[self setHiddenStatus:nextNumber status:NO]; 
			[self setHiddenStatus:nextNumberView status:NO];
		}
		if(seq >= 2){
			prevNumber.text = [[nums objectAtIndex:seq-2] stringValue];
			[self setHiddenStatus:prevNumber status:NO]; 
			[self setHiddenStatus:prevNumberView status:NO];
		}
		
		id sender; [self setRecoverResult:sender]; // 結果の再描写

		// ボタンの現在の情報も必要。

		
	}
		
}


// Override to allow orientations other than the default portrait orientation.
// デバイスの回転に関するメソッド（0.80a: 2010.05.06)
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
//    return (interfaceOrientation == UIInterfaceOrientationPortrait);
	return YES;
}

// http://blog.moonshine-project.com/ja/?p=53
// デバイスを回転前に実行 (0.80a: 2010.05.06)
- (void)willRotatetoInterfaceOrientation:(UIInterfaceOrientation)toInterfaceOrientation{
	
	//toInterfaceOrientation == 回転後の位置
	// 回転後の位置を記憶して、didRotateFromInterfaceOrientationで、回転前の位置と合わせて判断する。
	//willInterfaceOrientation = toInterfaceOrientation;
/*
	UIView *cview = self;
	if (toInterfaceOrientation == UIInterfaceOrientationLandscapeLeft ||
		toInterfaceOrientation == UIInterfaceOrientationLandscapeRight){
		CGSize size = cview.bounds.size;
		cview.center = CGPointMake(size.height / 2, size.width / 2);
		view.transform  = CGAffineTransformRotate(CGAffineTransformIdentity, (M_PI / 2.0));
		
	}
*/
 }

// デバイスを回転後に実行 (0.80a: 2010.05.06)
- (void)didRotateFromInterfaceOrientation:(UIInterfaceOrientation)fromInterfaceOrientation{
	//fromInterfaceOrientation == 回転前の位置

#if (__IPHONE_OS_VERSION_MAX_ALLOWED >= 30200)
    if (UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPad) {
		// iPadなら無視
	}else{
		// iPadでなければ縦横でフォントとUIlabelのサイズ変更（Y軸を2/3 --元に戻す）		
		
		// 横向きになったら
		if (fromInterfaceOrientation == UIInterfaceOrientationPortrait ||
			fromInterfaceOrientation == UIInterfaceOrientationPortraitUpsideDown){
			help_exp.frame = CGRectMake(help_exp.frame.origin.x,help_exp.frame.origin.y, help_exp.frame.size.width,help_exp.frame.size.height/3*2);
			help_exp.font = [UIFont systemFontOfSize:13];
		}
		else { // 縦向きになったら
			help_exp.frame = CGRectMake(help_exp.frame.origin.x,help_exp.frame.origin.y, help_exp.frame.size.width,help_exp.frame.size.height/2*3);
			help_exp.font = [UIFont systemFontOfSize:17];
		}

	}
#else
  // iPadでない（3.1.3以下）
	if (fromInterfaceOrientation == UIInterfaceOrientationPortrait ||
		fromInterfaceOrientation == UIInterfaceOrientationPortraitUpsideDown){
		help_exp.frame = CGRectMake(help_exp.frame.origin.x,help_exp.frame.origin.y, help_exp.frame.size.width,help_exp.frame.size.height/3*2);
		help_exp.font = [UIFont systemFontOfSize:13];
	}
	else {
		help_exp.frame = CGRectMake(help_exp.frame.origin.x,help_exp.frame.origin.y, help_exp.frame.size.width,help_exp.frame.size.height/2*3);
		help_exp.font = [UIFont systemFontOfSize:17];
	}
#endif
	
	if(fromInterfaceOrientation == UIInterfaceOrientationPortrait){
		// 縦向きでホームボタンが下（横向いたということ）
		//self.view.transform = CGAffineTransformMakeScale(0.5, 1.0);

	//	help_exp.sizeToFit;
		//self.view.transform = CGAffineTransformMakeRotation(M_PI * 90 / 180.0f);
	}else if(fromInterfaceOrientation == UIInterfaceOrientationPortraitUpsideDown){
		// 縦向きでホームボタンが上（１８０度）
	}else if(fromInterfaceOrientation == UIInterfaceOrientationLandscapeLeft){
		// 横向きでホームボタンが左（９０度）
		//self.view.autoresizingMask = UIViewAutoresizingFlexibleWidth;
		//help_exp.sizeToFit;

		//self.view.transform = CGAffineTransformMakeRotation(M_PI);
	}else if(fromInterfaceOrientation == UIInterfaceOrientationLandscapeRight){
		// 横向きでホームボタンが右（２７０度）

	}	
}


- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}

// 終了時の処理 (0.6) 2009.08.05
/*** AppDeletegate.mに下記を忘れないこと。
- (void)applicationWillTerminate:(UIApplication *)application {
[viewController willTerminate:application];
}
*****/
- (void)willTerminate: (UIApplication *)application
{
	LOG(@"### willTerminate\n");
	//NSMutableArray *array = [[[NSMutableArray alloc] initWithCapacity:1] autorelease];
	NSMutableArray *array = [NSMutableArray array]; // 0.61 2009.08.11: 上記と同じ意味
	// 必要なものをすべて下記のように列挙する。問題はリストアだねぇ。これはinitMeなどを使って
	// リストアしたものを適応していく必要があるのかなぁ。 [0.6]
	if(nums != nil && nums_status != nil && seq > 0){
		[array addObject: nums];
		[array addObject: nums_status];
		[array addObject: [NSNumber numberWithInt:maxOfSeq]];
		[array addObject: [NSNumber numberWithInt:seq]];
		[array addObject: resultNumber.text];
	// ボタンの現在の情報も必要。
	[self DataStore:array store:STORE_NAME];
	}else{
	// 何もせず終了したら、前のメモリを削除しておく 0.61: 2009.08.14
		[self DataRemove: STORE_NAME];
	}
}

- (void)dealloc {
    [HELP release];
    [exview release];
    [UserMode release];
    [self.view release];
    
    [super dealloc];
	
	//[scrollView release]; // 0.9: 外部出力用
}

@end
